
import allegro;
import sys;
#import OpenGL;
from OpenGL.GL import *;
from OpenGL.GLU import *;

from GLSLRenderer import GLSLRenderer;

import collada;

if not allegro.al_install_system(allegro.ALLEGRO_VERSION_INT, None):
	print("Failed to init Allegro.\n");
	sys.exit(1);

if not allegro.al_init_image_addon():
	print("Failed to init IIO addon.\n");
	sys.exit(1);

allegro.al_init_font_addon();

print allegro.al_get_num_video_adapters();

info = allegro.ALLEGRO_MONITOR_INFO();
allegro.al_get_monitor_info(0, allegro.byref(info));
w = info.x2 - info.x1;
h = info.y2 - info.y1;
	
w = 1024;
h = 768;
print w, h;
allegro.al_set_new_display_flags(allegro.ALLEGRO_WINDOWED | allegro.ALLEGRO_OPENGL);
display = allegro.al_create_display(w, h);
allegro.al_set_window_title(display, "[Allegro5 Python Test]");

if not display:
	print("Error installing keyboard.\n")
	sys.exit(1);

if not allegro.al_install_keyboard():
	print("Error installing keyboard.\n")
	sys.exit(1);

if not allegro.al_install_mouse():
	print("Error installing mouse.\n")
	sys.exit(1);
	
timer = allegro.al_create_timer(1.0 / 60.0)

queue = allegro.al_create_event_queue()
allegro.al_register_event_source(queue, allegro.al_get_keyboard_event_source())
allegro.al_register_event_source(queue, allegro.al_get_mouse_event_source())
allegro.al_register_event_source(queue, allegro.al_get_timer_event_source(timer))
allegro.al_register_event_source(queue, allegro.al_get_display_event_source(display))

allegro.al_start_timer(timer)

frames = 0;
prev_time = allegro.al_get_time();

# open COLLADA file ignoring some errors in case they appear
collada_file = collada.Collada("/home/uqsheat/workspace/pycollada/examples/daeview/data/cockpit.zip", 
	ignore=[collada.DaeUnsupportedError, collada.DaeBrokenRefError])
renderer = GLSLRenderer(collada_file);

glViewport(0, 0, w, h)
glMatrixMode(GL_PROJECTION)
glLoadIdentity()
gluPerspective(60., w / float(h), .1, 1000.)
glMatrixMode(GL_MODELVIEW)

while True:
	event = allegro.ALLEGRO_EVENT()

	if allegro.al_is_event_queue_empty(queue):
		allegro.al_clear_to_color(allegro.al_map_rgb_f(0, 0, 0));
		 
		renderer.render(0, 0, -20, 0, 0, 0);


		allegro.al_flip_display();
		frames += 1;

	allegro.al_wait_for_event(queue, allegro.byref(event));

	
	if event.type == allegro.ALLEGRO_EVENT_DISPLAY_CLOSE:
		break;

	current_time = allegro.al_get_time();	
	if current_time - prev_time > 10.0:
		fps = frames / (current_time - prev_time);
		allegro.al_set_window_title(display, "[Allegro5 Python Test] - FPS: %f" % fps);			
		frames = 0;
		prev_time = current_time;
	
	
